﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using HeuristicLab.Services.Hive.Statistics.Models;
using HeuristicLab.Services.Hive.DataAccess;

namespace HeuristicLab.Services.Hive.Statistics.Controllers {
  public class LoginRequiredController : Controller {
      
    [Authorize]
    public ActionResult UserTask() {
      var result = new UserModel {
        UserName = User.Identity.Name
      };

      //Initialize drop down list values
      var db = new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString);
      ViewBag.JobNames = new SelectList(db.DimJobs, "JobId", "JobName");
      var TaskStateList = (from task in db.FactTasks
                           select task.TaskState).Distinct();
      ViewBag.TaskStates = new SelectList(TaskStateList);

      return View(result);
    }

    [Authorize]
    public ActionResult Admin() {
      var result = new AdminModel {
        IsAdmin = false,
        UserName = User.Identity.Name
      };
      if (User.IsInRole("Hive Administrator")) {
        result.IsAdmin = true;

        //Initialize drop down list values
        var db = new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString);
        ViewBag.JobNames = new SelectList(db.DimJobs, "JobId", "JobName");
        var TaskStateList = (from task in db.FactTasks
                             select task.TaskState).Distinct();
        ViewBag.TaskStates = new SelectList(TaskStateList);
      }

      return View(result);
    }
  }
}
